// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/Util.h>
#include <Peer_impl.h>

#include <stdlib.h>

#ifdef HAVE_FSTREAM
#   include <fstream>
#else
#   include <fstream.h>
#endif

int
main(int argc, char* argv[], char*[])
{
    try
    {
	//
	// Create non-blocking ORB and BOA
	//
	CORBA_ORB_var orb = CORBA_ORB_init(argc, argv);
	orb -> nested(true);
	CORBA_BOA_var boa = orb -> BOA_init(argc, argv);
	
	//
	// Create implementation object
	//
	Peer_var p2 = new Peer_impl;
	
	//
	// Get other object
	//
	const char* refFile = "Peer.ref";
	ifstream in; // Must use open(name), not ifstream in(name) (VC++ bug)
	in.open(refFile);
	if(in.fail())
	{
	    extern int errno;
	    cerr << argv[0] << ": can't open `" << refFile << "': "
		 << strerror(errno) << endl;
	    return 1;
	}
	
	char s[1000];
	in >> s;

	CORBA_Object_var obj = orb -> string_to_object(s);
	assert(!CORBA_is_nil(obj));
	
	Peer_var p1 = Peer::_narrow(obj);
	assert(!CORBA_is_nil(p1));
	
	//
	// Start recursive decrement
	//
	cout << "Enter a number: ";
	CORBA_Long value;
	cin >> value;
	p1 -> decrement(value, p2);
    }
#ifdef __GNUG__
    catch(CORBA_COMM_FAILURE& ex)
#else
    catch(CORBA_SystemException& ex)
#endif
    {
	OBPrintException(ex);
	return 1;
    }

    return 0;
}

