// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package chat;

import org.omg.CORBA.*;
import java.util.*;
import java.io.*;

public class Server
{
    public static void
    main(String args[])
    {
        try
        {
            //
            // Create ORB and BOA
            //
            ORB orb = ORB.init(args, new java.util.Properties());
            BOA boa = orb.BOA_init(args, new java.util.Properties());

	    //
	    // Special OmniBroker ORB and BOA functions are needed
	    //
	    com.ooc.CORBA.BOA OBBOA = (com.ooc.CORBA.BOA)boa;
	    com.ooc.CORBA.ORB OBORB = (com.ooc.CORBA.ORB)orb;
 
            //
            // Create implementation object
            //
            Broadcaster_impl p = new Broadcaster_impl();
	    OBORB.connect(p, "Chat-Server");

	    //
	    // Save reference as html
	    //
	    try
	    {
		String ref = orb.object_to_string(p);
 		String refFile = "Chat.html";
		FileOutputStream file = new FileOutputStream(refFile);
		PrintStream out = new PrintStream(file);
		out.println("<applet codebase=\"classes\" " +
			    "code=\"chat/Client.class\" " +
			    "width=500 height=300>");
		out.println("<param name=ior value=\"" + ref + "\">");
		out.println("<param name=org.omg.CORBA.ORBClass " +
			    "value=com.ooc.CORBA.IIOPORB>");
		out.println("<param name=org.omg.CORBA.ORBSingletonClass " +
			    "value=com.ooc.CORBA.ORBSingleton>");
		out.println("</applet>");
		out.flush();
		file.close();
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't write to `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }

	    //
	    // Print "server started" message
	    //
	    Date date = new Date();
	    String d = date.toString();
	    System.out.println("*** Server started at " + d);;

	    //
	    // Print host and port
	    //
	    System.out.println("*** Running on host `" + OBBOA.host() +
			       "', port number " + OBBOA.port());

            //
            // Run implementation
            //
            boa.impl_is_ready(null);
 
            System.exit(0);
        }
        catch(SystemException ex)
        {
            System.err.println(ex.getMessage());
            ex.printStackTrace();
            System.exit(1);
        }
    }
}
