// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package nested;

import org.omg.CORBA.*;
import java.io.*;

public class Peer2
{
    public static void main(String args[])
    {
	try
	{
            //
            // Create ORB and BOA
            //
            ORB orb = ORB.init(args, new java.util.Properties());
	    BOA boa = orb.BOA_init(args, new java.util.Properties());
	    ((com.ooc.CORBA.BOA)boa).set_thread_model(
		com.ooc.CORBA.ThreadModel.ThreadPerRequest);

	    //
	    // Create implementation object
	    //
	    Peer_impl p2 = new Peer_impl();

	    //
	    // Get other object
	    //
	    String ref = null;
	    try
	    {
		String refFile = "Peer.ref";
		FileInputStream file = new FileInputStream(refFile);
		DataInputStream in = new DataInputStream(file);
		ref = in.readLine();
		file.close();
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't read from `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }

	    org.omg.CORBA.Object obj = orb.string_to_object(ref);
	    if(obj == null)
		throw new RuntimeException();

	    Peer p1 = PeerHelper.narrow(obj);

	    //
	    // Start recursive decrement
	    //
	    try
	    {
		System.out.print("Enter a number: ");
		DataInputStream dataIn = new DataInputStream(System.in);
		String number = dataIn.readLine();
		Integer integer = new Integer(number);
		p1.decrement(new IntHolder(integer.intValue()), p2);
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't read from `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }

	    System.exit(0);
	}
	catch(SystemException ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
}
