// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package test;

import java.io.*;
import org.omg.CORBA.*;

public class Server
{
    static public int
    run(ORB orb, String args[])
    {
	//
	// Create BOA (This is OmniBroker specific)
        //
	BOA boa = orb.BOA_init(args, new java.util.Properties());
	
	//
	// Create implementation objects
	//
	TestInterfaceTimeout i = new TestInterfaceTimeout_impl(boa);
	org.omg.CORBA.Object p = i;
	String impl = orb.object_to_string(p);
    
	TestInterfaceExDSI_impl iDSI = new TestInterfaceExDSI_impl(i);
	org.omg.CORBA.Object pDSI = iDSI;
	String implDSI = orb.object_to_string(pDSI);

	//
	// Save references
	//
	String refFile = "TestInterface.ref";
	try
	{
	    FileOutputStream file = new FileOutputStream(refFile);
	    PrintStream out = new PrintStream(file);
	    out.println(impl);
	    out.println(implDSI);
	    out.flush();
	    file.close();
 	}
	catch(IOException ex)
	{
	    System.err.println("Can't write to `" +
			       ex.getMessage() + "'");
	    return 1;
	}

	//
	// Run implementation
	//
	boa.impl_is_ready(null);

	//
	// Delete reference file
	//
 	File file = new File(refFile);
 	file.delete();

	return 0;
    }

    static public void
    main(String args[])
    {
	int status = 0;

        try
        {
            //
            // Create ORB
            //
            org.omg.CORBA.ORB orb = ORB.init(args, new java.util.Properties());
 
	    //
	    // Run tests
	    //
	    status = run(orb, args);
	}
	catch(SystemException ex)
        {
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	}

	System.exit(status);
    }
}
