# **********************************************************************
#
# Copyright (c) 1997
# Object-Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

SERVER_NAME	= server.exe
CLIENT_NAME	= client.exe

TARGETS		= $(SERVER_NAME) \
		  $(CLIENT_NAME)

!include $(top_srcdir)\config\Make.rules.mak

OB_LIBS		= $(top_srcdir)\lib\ob.lib

COMMON_OBJS	= Test1.obj \
		  Test2.obj

SERVER_OBJS	= Server.obj \
		  Test1_skel.obj \
		  Test2_skel.obj \
		  Test_impl.obj \
		  TestDSI_impl.obj

CLIENT_OBJS	= Client.obj \
		  TestConst.obj \
		  TestTypeCode.obj \
		  TestAny.obj \
		  TestUnion.obj \
		  TestStub.obj \
		  TestStubContext.obj \
		  TestStubException.obj \
		  TestStubTimeout.obj \
		  TestDII.obj \
		  TestDIIException.obj \
		  TestDIIContext.obj

SRCS		= $(COMMON_OBJS:.obj=.cpp) \
		  $(SERVER_OBJS:.obj=.cpp) \
		  $(CLIENT_OBJS:.obj=.cpp)

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= $(CPPFLAGS) -I. -I$(top_srcdir)\include 
ALL_DEFS	= $(DEFS)
ALL_LINKFLAGS	= $(LINKFLAGS)
ALL_LINKGUIFLAGS = $(LINKGUIFLAGS)
ALL_LIBS	= $(OB_LIBS) $(LIBS)
ALL_GUILIBS	= $(OB_LIBS) $(GUILIBS)

$(SERVER_NAME): $(COMMON_OBJS) $(SERVER_OBJS) $(OB_LIBS)
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(SERVER_OBJS) $(ALL_LIBS)

$(CLIENT_NAME): $(COMMON_OBJS) $(CLIENT_OBJS) $(OB_LIBS)
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(CLIENT_OBJS) $(ALL_LIBS)

clean::
	@del $(TARGETS)

!include .windep
