// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/Util.h>
#include <Test1.h>
#include <Test2.h>
#include <TestMacro.h>

#ifdef HAVE_UNISTD_H
#   include <unistd.h>
#endif

#include <time.h>

void
TestStubTimeout(TestInterfaceTimeout_ptr ti)
{
    CORBA_Long timeout = ti -> _timeout();

    ti -> _timeout(4000);

    ti -> sleepOneway(6);

    try
    {
	ti -> sleepTwoway(0);
	TEST(false);
    }
    catch(const CORBA_NO_RESPONSE&)
    {
    }

#ifdef WIN32
    Sleep(4000);
#else
    sleep(4);
#endif

    try
    {
	ti -> sleepTwoway(0);
    }
    catch(const CORBA_NO_RESPONSE&)
    {
	TEST(false);
    }

    ti -> _timeout(timeout);
}


